diff --git a/src/window.c b/src/window.c
index 881bbd5..f252a36 100644
--- a/src/window.c
+++ b/src/window.c
@@ -3864,7 +4170,7 @@ moveResizeWindow (CompWindow     *w,
 	{
 	    int min, max;
 
-	    min = w->screen->workArea.x + w->input.left;
+	    min = w->screen->workArea.x - w->serverWidth;
 	    max = w->screen->workArea.x + w->screen->workArea.width;
 
 	    min -= w->screen->x * w->screen->width;
@@ -3975,7 +4281,7 @@ addWindowStackChanges (CompWindow     *w,
 	    if (!sibling)
 	    {
 		XLowerWindow (w->screen->display->display, w->id);
-		if (w->frame)
+		if (w->frame && w->parent->substructureRedirect)
 		    XLowerWindow (w->screen->display->display, w->frame);
 	    }
 	    else if (sibling->id != w->prev->id)
@@ -4008,7 +4314,7 @@ addWindowStackChanges (CompWindow     *w,
 	{
 	    CompWindow *dw;
 
-	    for (dw = w->screen->reverseWindows; dw; dw = dw->prev)
+	    for (dw = w->parent->reverseWindows; dw; dw = dw->prev)
 		if (dw == sibling)
 		    break;
 
@@ -4073,7 +4379,7 @@ findValidStackSiblingBelow (CompWindow *w,
     lowest = last = findLowestSiblingBelow (w);
 
     /* walk from bottom up */
-    for (p = w->screen->windows; p; p = p->next)
+    for (p = w->parent->windows; p; p = p->next)
     {
 	/* stop walking when we reach the sibling we should try to stack
 	   below */
@@ -4122,7 +4428,7 @@ updateWindowAttributes (CompWindow             *w,
     XWindowChanges xwc;
     int		   mask = 0;
 
-    if (w->attrib.override_redirect || !w->managed)
+    if (!w->managed)
 	return;
 
     if (w->state & CompWindowStateShadedMask)
@@ -4200,7 +4506,7 @@ ensureWindowVisibility (CompWindow *w)
     int dx = 0;
     int dy = 0;
 
-    if (w->struts || w->attrib.override_redirect)
+    if (w->struts || !w->managed)
 	return;
 
     if (w->type & (CompWindowTypeDockMask	|
@@ -4259,6 +4565,34 @@ revealAncestors (CompWindow *w,
 void
 activateWindow (CompWindow *w)
 {
+    if (!w->parent->substructureRedirect)
+    {
+	XEvent xev;
+	int    mask = 0;
+
+	xev.xclient.type    = ClientMessage;
+	xev.xclient.display = w->screen->display->display;
+	xev.xclient.format  = 32;
+
+	xev.xclient.message_type = w->screen->display->winActiveAtom;
+	xev.xclient.window	 = w->id;
+
+	xev.xclient.data.l[0] = 2; /* pretend to be a pager */
+	xev.xclient.data.l[1] = 0;
+	xev.xclient.data.l[2] = 0;
+	xev.xclient.data.l[3] = 0;
+	xev.xclient.data.l[4] = 0;
+
+	if (w->parent == &w->screen->root)
+	    mask = SubstructureRedirectMask | SubstructureNotifyMask;
+
+	XSendEvent (w->screen->display->display, w->parent->id, FALSE,
+		    mask,
+		    &xev);
+
+	return;
+    }
+
     setCurrentDesktop (w->screen, w->desktop);
 
     forEachWindowOnScreen (w->screen, revealAncestors, (void *) w);
@@ -4511,7 +4845,8 @@ hideWindow (CompWindow *w)
 
 	w->shaded = FALSE;
 
-	if ((w->state & CompWindowStateShadedMask) && w->frame)
+	if ((w->state & CompWindowStateShadedMask) &&
+	    w->frame && w->parent->substructureRedirect)
 	    XUnmapWindow (w->screen->display->display, w->frame);
     }
 
@@ -4551,7 +4886,7 @@ showWindow (CompWindow *w)
     {
 	w->shaded = TRUE;
 
-	if (w->frame)
+	if (w->frame && w->parent->substructureRedirect)
 	    XMapWindow (w->screen->display->display, w->frame);
 
 	if (w->height)
@@ -4633,7 +4968,7 @@ void
 maximizeWindow (CompWindow *w,
 		int	   state)
 {
-    if (w->attrib.override_redirect)
+    if (!w->managed)
 	return;
 
     state = constrainWindowState (state, w->actions);
@@ -4770,7 +5105,7 @@ isWindowFocusAllowed (CompWindow   *w,
     {
 	CompWindow *parent;
 
-	parent = findWindowAtScreen (w->screen, w->transientFor);
+	parent = findSibling (w, w->transientFor);
 	if (parent)
 	    gotTimestamp = getUsageTimestampForWindow (parent, &wUserTime);
     }
@@ -4880,7 +5215,7 @@ unredirectWindow (CompWindow *w)
 void
 redirectWindow (CompWindow *w)
 {
-    if (w->redirected)
+    if (!w->parent || !w->parent->redirectSubwindows || w->redirected)
 	return;
 
     XCompositeRedirectWindow (w->screen->display->display, w->id,
@@ -5199,3 +5534,151 @@ getWindowMovementForOffset (CompWindow *w,
     }
 
 }
+
+void
+enterSyncWaitState (CompWindow *w)
+{
+    XDeleteProperty (w->screen->display->display,
+		     w->id,
+		     w->screen->display->syncStateAtom);
+}
+
+void
+leaveSyncWaitState (CompWindow *w)
+{
+    unsigned long data = XSyncValueLow32 (w->syncValue);
+
+    XChangeProperty (w->screen->display->display,
+		     w->id,
+		     w->screen->display->syncStateAtom,
+		     XA_CARDINAL,
+		     32,
+		     PropModeReplace,
+		     (unsigned char *) &data, 1);
+}
+
+void
+insertWindow (CompWindow *parent,
+	      CompWindow *w,
+	      Window	 aboveId)
+{
+    CompWindow *p;
+
+    if (parent->windows)
+    {
+	if (!aboveId)
+	{
+	    w->next = parent->windows;
+	    w->prev = NULL;
+	    parent->windows->prev = w;
+	    parent->windows = w;
+	}
+	else
+	{
+	    for (p = parent->windows; p; p = p->next)
+	    {
+		if (p->id == aboveId)
+		{
+		    if (p->next)
+		    {
+			w->next = p->next;
+			w->prev = p;
+			p->next->prev = w;
+			p->next = w;
+		    }
+		    else
+		    {
+			p->next = w;
+			w->next = NULL;
+			w->prev = p;
+			parent->reverseWindows = w;
+		    }
+		    break;
+		}
+	    }
+
+#ifdef DEBUG
+	    if (!p)
+		abort ();
+#endif
+
+	}
+    }
+    else
+    {
+	parent->reverseWindows = parent->windows = w;
+	w->prev = w->next = NULL;
+    }
+}
+
+void
+unhookWindow (CompWindow *parent,
+	      CompWindow *w)
+{
+    CompWindow *next, *prev;
+
+    next = w->next;
+    prev = w->prev;
+
+    if (next || prev)
+    {
+	if (next)
+	{
+	    if (prev)
+	    {
+		next->prev = prev;
+	    }
+	    else
+	    {
+		parent->windows = next;
+		next->prev = NULL;
+	    }
+	}
+
+	if (prev)
+	{
+	    if (next)
+	    {
+		prev->next = next;
+	    }
+	    else
+	    {
+		parent->reverseWindows = prev;
+		prev->next = NULL;
+	    }
+	}
+    }
+    else
+    {
+	parent->windows = parent->reverseWindows = NULL;
+    }
+
+    if (w == lastFoundWindow)
+	lastFoundWindow = NULL;
+    if (w == lastDamagedWindow)
+	lastDamagedWindow = NULL;
+}
+
+CompWindow *
+findSibling (CompWindow *w,
+	     Window     id)
+{
+    if (w->parent)
+	for (w = w->parent->windows; w; w = w->next)
+	    if (w->id == id)
+		return w;
+
+    return NULL;
+}
+
+CompWindow *
+walkDepthFirst (CompWindow *w)
+{
+    if (w->windows)
+        return w->windows;
+
+    while (!w->next && w->parent)
+        w = w->parent;
+
+    return w->next;
+}
